/*---

    iGeo - http://igeo.jp

    Copyright (c) 2002-2013 Satoru Sugihara

    This file is part of iGeo.

    iGeo is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation, version 3.

    iGeo is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with iGeo.  If not, see <http://www.gnu.org/licenses/>.

---*/

package igeo;

/**
   Abstract Scalar (1D) Value Interface
   @author Satoru Sugihara
*/

public interface IArithmeticVal<T,S> extends IVal{
    public T add(T val);
    public T sub(T val);
    public T mul(S val);
    public T div(S val);
    public T zero();
    public T dup(); 
    public T cp(); // alias of dup
    public T set(T val); 
}
